// -*- C++ -*-
/*!
 * @file  RTC_GameController.h
 * @brief PS4&XBOX360?
 * @date  $Date$
 *
 * $Id$
 */

#ifndef RTC_GAMECONTROLLER_H
#define RTC_GAMECONTROLLER_H

#include <rtm/idl/BasicDataTypeSkel.h>
#include <rtm/idl/ExtendedDataTypesSkel.h>
#include <rtm/idl/InterfaceDataTypesSkel.h>

// Service implementation headers
// <rtc-template block="service_impl_h">

// </rtc-template>

// Service Consumer stub headers
// <rtc-template block="consumer_stub_h">

// </rtc-template>

// Service Consumer stub headers
// <rtc-template block="port_stub_h">
// </rtc-template>

using namespace RTC;

#include <rtm/Manager.h>
#include <rtm/DataFlowComponentBase.h>
#include <rtm/CorbaPort.h>
#include <rtm/DataInPort.h>
#include <rtm/DataOutPort.h>

#include <stdio.h>
#include <linux/joystick.h>

extern char SNC[50];
extern char WireC[50];
extern char BOX[50];
extern double pre_AXES[50];
extern int  Device_MODE;
struct  GC_state{
	char NAME[256];
	char BUTTON[50];
	int Pre_AXES[50];
	double AXES[50];
	double HAT[10];
	};

/*!
 * @class RTC_GameController
 * @brief PS4&XBOX360?？？？？？
 *
 * PS4コン、XBOX３６０コンで
 *
 */
class RTC_GameController
  : public RTC::DataFlowComponentBase
{
 public:
  /*!
   * @brief constructor
   * @param manager Maneger Object
   */
  RTC_GameController(RTC::Manager* manager);

  /*!
   * @brief destructor
   */
  ~RTC_GameController();

  // <rtc-template block="public_attribute">
  
  // </rtc-template>

  // <rtc-template block="public_operation">
  
  // </rtc-template>

  /***
   *
   * The initialize action (on CREATED->ALIVE transition)
   * formaer rtc_init_entry() 
   *
   * @return RTC::ReturnCode_t
   * 
   * 
   */
   virtual RTC::ReturnCode_t onInitialize();

  /***
   *
   * The finalize action (on ALIVE->END transition)
   * formaer rtc_exiting_entry()
   *
   * @return RTC::ReturnCode_t
   * 
   * 
   */
  // virtual RTC::ReturnCode_t onFinalize();

  /***
   *
   * The startup action when ExecutionContext startup
   * former rtc_starting_entry()
   *
   * @param ec_id target ExecutionContext Id
   *
   * @return RTC::ReturnCode_t
   * 
   * 
   */
   virtual RTC::ReturnCode_t onStartup(RTC::UniqueId ec_id);

  /***
   *
   * The shutdown action when ExecutionContext stop
   * former rtc_stopping_entry()
   *
   * @param ec_id target ExecutionContext Id
   *
   * @return RTC::ReturnCode_t
   * 
   * 
   */
  // virtual RTC::ReturnCode_t onShutdown(RTC::UniqueId ec_id);

  /***
   *
   * The activated action (Active state entry action)
   * former rtc_active_entry()
   *
   * @param ec_id target ExecutionContext Id
   *
   * @return RTC::ReturnCode_t
   * 
   * 
   */
   virtual RTC::ReturnCode_t onActivated(RTC::UniqueId ec_id);

  /***
   *
   * The deactivated action (Active state exit action)
   * former rtc_active_exit()
   *
   * @param ec_id target ExecutionCom_R_StickOutntext Id
   *
   * @return RTC::ReturnCode_t
   * 
   * 
   */
   virtual RTC::ReturnCode_t onDeactivated(RTC::UniqueId ec_id);

  /***
   *
   * The execution action that is invoked periodically
   * former rtc_active_do()
   *
   * @param ec_id target ExecutionContext Id
   *
   * @return RTC::ReturnCode_t
   * 
   * 
   */
   virtual RTC::ReturnCode_t onExecute(RTC::UniqueId ec_id);

  /***
   *
   * The aborting action when main logic error occurred.
   * former rtc_aborting_entry()
   *
   * @param ec_id target ExecutionContext Id
   *
   * @return RTC::ReturnCode_t
   * 
   * 
   */
  // virtual RTC::ReturnCode_t onAborting(RTC::UniqueId ec_id);

  /***
   *
   * The error action in ERROR state
   * former rtc_error_do()
   *
   * @param ec_id target ExecutionContext Id
   *
   * @return RTC::ReturnCode_t
   * 
   * 
   */
  // virtual RTC::ReturnCode_t onError(RTC::UniqueId ec_id);

  /***
   *
   * The reset action that is invoked resetting
   * This is same but different the former rtc_init_entry()
   *
   * @param ec_id target ExecutionContext Id
   *
   * @return RTC::ReturnCode_t
   * 
   * 
   */
  // virtual RTC::ReturnCode_t onReset(RTC::UniqueId ec_id);
  
  /***
   *
   * The state update action that is invoked after onExecute() action
   * no corresponding operation exists in OpenRTm-aist-0.2.0
   *
   * @param ec_id target ExecutionContext Id
   *
   * @return RTC::ReturnCode_t
   * 
   * 
   */
  // virtual RTC::ReturnCode_t onStateUpdate(RTC::UniqueId ec_id);

  /***
   *
   * The action that is invoked when execution context's rate is changed
   * no corresponding operation exists in OpenRTm-aist-0.2.0
   *
   * @param ec_id target ExecutionContext Id
   *
   * @return RTC::ReturnCode_t
   * 
   * 
   */
  // virtual RTC::ReturnCode_t onRateChanged(RTC::UniqueId ec_id);


 protected:


/*!
   * 
   * - Name:  Klx
   * - DefaultValue: 1.0
   */

  double m_K_Vx;


/*!
   * 
   * - Name:  Klx
   * - DefaultValue: 1.0
   */

  double m_K_Vy;


/*!
   * 
   * - Name:  Klx
   * - DefaultValue: 1.0
   */

  double m_K_Va;


/*!
   * 
   * - Name:  Klx
   * - DefaultValue: 1.0
   */

  double m_K_Stick;
  // <rtc-template block="protected_attribute">
  
  // </rtc-template>

  // <rtc-template block="protected_operation">
  
  // </rtc-template>

  // Configuration variable declaration
  // <rtc-template block="config_declare">

  // </rtc-template>

  // DataInPort declarationm_R_StickOut
  // <rtc-template block="inport_declare">
  
  // </rtc-template>


  // DataOutPort declaration
  // <rtc-template block="outport_declare">
  RTC::TimedULong m_Button;
  /*!
   */
  OutPort<RTC::TimedULong> m_ButtonOut;
  RTC::TimedDouble m_L_Stick_X;
  /*!
   */
  OutPort<RTC::TimedDouble> m_L_Stick_XOut;
  RTC::TimedDouble m_L_Stick_Y;
  /*!
   */
  OutPort<RTC::TimedDouble> m_L_Stick_YOut;

  RTC::TimedDouble m_R_Stick_X;
  /*!
   */
  OutPort<RTC::TimedDouble> m_R_Stick_XOut;
  RTC::TimedDouble m_R_Stick_Y;
  /*!
   */
  OutPort<RTC::TimedDouble> m_R_Stick_YOut;

  RTC::TimedDouble m_L2_Analog;
  /*!
   */
  OutPort<RTC::TimedDouble> m_L2_AnalogOut;
  RTC::TimedDouble m_R2_Analog;
  /*!
   */
  OutPort<RTC::TimedDouble> m_R2_AnalogOut;

  RTC::TimedVelocity2D m_Velocity;
  /*!
   */
  OutPort<RTC::TimedVelocity2D> m_VelocityOut;


  RTC::TimedDoubleSeq m_Analog;
  /*!
   */
  OutPort<RTC::TimedDoubleSeq> m_AnalogOut;
  
  
  RTC::TimedString m_Controller_Type;
  
  OutPort<RTC::TimedString> m_Controller_TypeOut;
  
  
  
  
  // </rtc-template>

  // CORBA Port declaration
  // <rtc-template block="corbaport_declare">
  
  // </rtc-template>

  // Service declaration
  // <rtc-template block="service_declare">
  
  // </rtc-template>

  // Consumer declaration
  // <rtc-template block="consumer_declare">
  
  // </rtc-template>

 private:
  // <rtc-template block="private_attribute">
  
  // </rtc-template>

  // <rtc-template block="private_operation">
  
  // </rtc-template>

};


extern "C"
{
  DLL_EXPORT void RTC_GameControllerInit(RTC::Manager* manager);
};


unsigned long Game_Controller_Button_Read();
int Game_Controller_AXES_Read();
int Game_Controller_Type_Find(const char* device);
int Game_Controller_Close(const char* device);



#endif // RTC_GAMECONTROLLER_H
